Hooks:PostHook(NetworkPeer, "set_class", "PlayerInfo_NetworkPeer_post_set_class",
    function(self)
        if not (self._unit and managers.network and managers.criminals) then
            return
        end
        local peer = managers.network:session():peer_by_unit(self._unit)
        local data = managers.criminals:character_data_by_peer_id(peer:id())
        local teammate_id = data and data.panel_id or nil
        if teammate_id then
            PlayerInfo:SetPlayerClass(teammate_id, self._class, true)
            if self._profile.outfit_string then
                PlayerInfo:SetPlayerOutfitString(teammate_id,
                    self._profile.outfit_string, self._outfit_version, self._signature, true)
            end
        end
    end
)

Hooks:PostHook(NetworkPeer, "set_outfit_string", "PlayerInfo_NetworkPeer_post_set_outfit_string",
    function(self, outfit_string, outfit_version, outfit_signature)
        if self == managers.network:session():local_peer() then
            return
        end
        if outfit_string ~= self._profile.outfit_string then
            return
        end
        if not (self._unit and managers.network and managers.criminals) then
            return
        end
        local peer = managers.network:session():peer_by_unit(self._unit)
        local data = managers.criminals:character_data_by_peer_id(peer:id())
        local teammate_id = data and data.panel_id or nil
        if teammate_id then
            PlayerInfo:SetPlayerOutfitString(teammate_id,
                self._profile.outfit_string, self._outfit_version, self._signature, true)
        end
    end
)
