PlayerInfoMenu = PlayerInfoMenu or class(BLTMenu)

function PlayerInfoMenu:Init(root)
	self._something_changed = false

	self:_MakeHeader()

	self:_MakeOptionToggle("add_self")

	self:_MakeSeperator()

	self:_MakeOptionToggle("show_nationality")
	self:_MakeOptionToggle("show_level")

	self:_MakeSeperator()

	self:_MakeOptionToggle("show_weapons")
	self:_MakeOptionToggle("include_grenade")

	self:_MakeSeperator()

	self:_MakeOptionToggle("show_warcry")
	self:_MakeOptionToggle("show_boost")
	self:_MakeOptionToggle("show_skills")

	self:_MakeSeperator()

	self:_MakeOptionToggle("add_background")

	self:_MakeResetButton()
end

function PlayerInfoMenu:_MakeHeader()
	self:Title({
		text = "playerinfo_title",
	})
	self:Label({
		text = nil,
		localize = false,
		h = 8,
	})
end

function PlayerInfoMenu:_MakeResetButton()
	self:LongRoundedButton2({
		name = "playerinfo_reset",
		text = "playerinfo_reset",
		localize = true,
		callback = callback(self, self, "Reset"),
		ignore_align = true,
		y = 832,
		x = 1472,
	})
end

function PlayerInfoMenu:_MakeSeperator(text)
	self:SubTitle({ text = text, localize = false, y_offset = text and 0 or 8 })
end

function PlayerInfoMenu:_MakeOptionToggle(option)
	local id = "playerinfo_" .. option
	self:Toggle({
		name = id,
		text = id,
		desc = id .. "_desc",
		value = PlayerInfo:GetConfigOption(option),
		callback = callback(self, self, "OnOptionChanged", option),
	})
end

function PlayerInfoMenu:OnOptionChanged(option, value)
	if PlayerInfo:SetConfigOption(option, value) then
		self._something_changed = true
	end
end

function PlayerInfoMenu:Reset(value, item)
	QuickMenu:new(
		managers.localization:text("playerinfo_reset"),
		managers.localization:text("playerinfo_reset_confirm"),
		{
			[1] = {
				text = managers.localization:text("dialog_no"),
				is_cancel_button = true,
			},
			[2] = {
				text = managers.localization:text("dialog_yes"),
				callback = function()
					-- reset config
					PlayerInfo:LoadConfigDefaults()
					PlayerInfo:SaveConfig()
					-- reset menu
					self._something_changed = false
					self:ReloadMenu()
				end,
			},
		},
		true
	)
end

function PlayerInfoMenu:Close()
	if self._something_changed then
		PlayerInfo:SaveConfig()
	end
end

Hooks:Add("MenuComponentManagerInitialize", "PlayerInfo.MenuComponentManagerInitialize",
	function(self)
		RaidMenuHelper:CreateMenu({
			name = "playerinfo_options",
			name_id = "playerinfo_title",
			inject_menu = "blt_options",
			class = PlayerInfoMenu
		})
	end
)
