RaidMainMenuGui.KICK_MUTE_WIDGET_HEADER_HEIGHT = 64

Hooks:PreHook(RaidMainMenuGui, "init",
    "PlayerInfo_RaidMainMenuGui_pre_init",
    function(self)
        self._player_info_add_self = PlayerInfo:GetConfigOption("add_self")
    end
)

Hooks:PostHook(RaidMainMenuGui, "_layout",
    "PlayerInfo_RaidMainMenuGui_post__layout",
    function(self)
        -- force draw kick_mute_widget, in single player when showing local player
        -- why such a weird if statement? - because MP is handled by vanilla code, we dont wanna do it multiple times then.
        if self._player_info_add_self and ((managers.raid_job and managers.raid_job:is_in_tutorial()) or managers.platform:rich_presence() == "SPPlaying") then
            self:_layout_kick_mute_widget()
        end
    end
)

Hooks:PostHook(RaidMainMenuGui, "_layout_kick_mute_widget",
    "PlayerInfo_RaidMainMenuGui_post__layout_kick_mute_widget",
    function(self)
        if self._player_info_add_self then
            self._widgets = self._widgets or {}
            self._widget_label_panel:set_visible(true)

            local original_widgets = #self._widgets

            -- add player widget
            local index = original_widgets + 1
            local widget = self._widget_panel:create_custom_control(RaidGUIControlKickMuteWidget, {
                index = index,
                name = "local_player_kick_mute_widget",
                y = RaidGUIControlKickMuteWidget.HEIGHT,
                menu_move = {
                    left = "list_menu"
                },
                on_button_selected_callback = callback(self, self, "on_widget_button_selected"),
                on_button_unselected_callback = callback(self, self, "on_widget_button_unselected")
            })
            widget:set_is_local_player()
            widget:set_visible(true)
            table.insert(self._widgets, widget)
            managers.menu_component:gather_controls_for_component(self._name)
        end

        -- fix overall size
        local largest_w = 0
        for i = 1, #self._widgets do
            local w = self._widgets[i]:calculate_width()
            if largest_w < w then
                largest_w = w
            end
            self._widgets[i]:set_move_controls(i, false)
        end
        self._widget_panel:set_w(largest_w)
        self._widget_panel:set_right(self._root_panel:w())
        self._widget_panel:set_h(RaidMainMenuGui.KICK_MUTE_WIDGET_HEADER_HEIGHT +
            (#self._widgets * RaidGUIControlKickMuteWidget.HEIGHT))

        -- fix widgets sizes/positions
        for i = 1, #self._widgets do
            self._widgets[i]:set_w(largest_w)
            self._widgets[i]:set_y(RaidMainMenuGui.KICK_MUTE_WIDGET_HEADER_HEIGHT +
                (self._widgets[i]._is_local_player and 0 or (i * RaidGUIControlKickMuteWidget.HEIGHT)))
        end

        -- fix tooltip label size
        local widget_title = self._widget_label_panel:child("widget_title")
        if widget_title and self._widget_action_title then
            local _, _, w = widget_title:text_rect()
            self._widget_action_title:set_w(self._widget_label_panel:w() - (self._widget_label_panel:x() + w + 32))
            self._widget_action_title:set_right(self._widget_label_panel:w())
        end
    end
)
